'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _twemoji = require('twemoji');

var _twemoji2 = _interopRequireDefault(_twemoji);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Header = function (_React$Component) {
  (0, _inherits3.default)(Header, _React$Component);

  function Header(props) {
    (0, _classCallCheck3.default)(this, Header);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Header.__proto__ || (0, _getPrototypeOf2.default)(Header)).call(this, props));

    _this.state = {
      mounted: false
    };
    return _this;
  }

  (0, _createClass3.default)(Header, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({
        mounted: true
      });
    }
  }, {
    key: 'createTimestamp',
    value: function createTimestamp(time) {
      if (!time || !this.state.mounted) return null;

      var parseTwitterDate = function parseTwitterDate(tdate) {
        var system_date = new Date(Date.parse(tdate));
        var user_date = new Date();

        var diff = Math.floor((user_date - system_date) / 1000);
        if (diff < 59) {
          return diff + "s";
        }
        if (diff <= 3540) {
          return Math.round(diff / 60) + "m";
        }
        if (diff <= 86400) {
          return Math.round(diff / 3600) + "h";
        }
        if (diff < 604800) {
          return Math.round(diff / 86400) + "d";
        }
        return system_date.toString().substring(4, 10);
      };

      return parseTwitterDate(time);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          data = _props.data,
          linkProps = _props.linkProps;

      var timestamp = this.createTimestamp(data.created_at);

      var name = data.user.name;

      name = _twemoji2.default.parse(name);
      name = name.replace(/<img class="emoji"/g, '<img class="emoji" style="height:14px;margin-right:5px;"');

      return _react2.default.createElement(
        'div',
        { className: 'header' },
        _react2.default.createElement(
          'a',
          (0, _extends3.default)({ className: 'account-group', style: _styles2.default.accountGroup, href: 'https://twitter.com/' + data.user.screen_name }, linkProps),
          _react2.default.createElement('img', { className: 'avatar', src: data.user.profile_image_url_https, style: _styles2.default.avatar }),
          _react2.default.createElement(
            'strong',
            { className: 'fullname', style: _styles2.default.fullname },
            data.user.name,
            ' '
          ),
          _react2.default.createElement(
            'span',
            null,
            '\u200F'
          ),
          _react2.default.createElement(
            'span',
            { className: 'username', style: _styles2.default.username },
            _react2.default.createElement(
              's',
              { style: _styles2.default.s },
              '@'
            ),
            _react2.default.createElement(
              'b',
              { style: _styles2.default.b },
              data.user.screen_name
            )
          )
        ),
        _react2.default.createElement(
          'small',
          { className: 'time', style: _styles2.default.time },
          _react2.default.createElement(
            'a',
            (0, _extends3.default)({ href: 'https://twitter.com/' + data.user.screen_name + '/status/' + data.id_str, className: 'tweet-timestamp', style: _styles2.default.timestamp }, linkProps),
            ' • ',
            timestamp
          )
        )
      );
    }
  }]);
  return Header;
}(_react2.default.Component);

Header.defaultProps = {
  'data': {
    'user': {}
  }
};

Header.displayName = 'Header';

exports.default = Header;